---
title: USBInterface
slug: Web/API/USBInterface
tags:
  - API
  - Experimental
  - Interface
  - NeedsExample
  - Reference
  - USBInterface
  - WebUSB
  - WebUSB API
---
<div>{{draft}}{{securecontext_header}}{{APIRef("WebUSB API")}}</div>

<p>The <code>USBInterface</code> interface of the <a href="/en-US/docs/Web/API/WebUSB_API" rel="nofollow">WebUSB API</a> provides information about an interface provided by the USB device. An interface represents a feature of the device which implements a particular protocol and may contain endpoints for bidirectional communication.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("USBInterface.USBInterface")}}</dt>
 <dd>Creates a new <code>USBInterface</code> object which will be populated with information about the interface on the provided <code>USBConfiguration</code> with the given interface number.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("USBInterface.interfaceNumber")}}{{readonlyInline}}</dt>
 <dd>Returns the interface number of this interface. This is equal to the <code>bInterfaceNumber</code> field of the interface descriptor defining this interface.</dd>
 <dt>{{domxref("USBInterface.alternate")}}{{readonlyInline}}</dt>
 <dd>Returns the currently selected alternative configuration of this interface. By default this is the <code>USBAlternateInterface</code> from <code>alternates</code> with <code>alternateSetting</code> equal to <code>0</code>. It can be changed by calling <code>USBDevice.selectAlternateInterface()</code> with any other value found in <code>alternates</code>.</dd>
 <dt>{{domxref("USBInterface.alternates")}}{{readonlyInline}}</dt>
 <dd>Returns an array containing instances of the <code>USBAlternateInterface</code> interface describing each of the alternative configurations possible for this interface.</dd>
 <dt><strong>{{domxref("USBInterface.claimed")}}</strong>{{readonlyInline}}</dt>
 <dd>Returns whether or not this interface has been claimed by the current page by calling <code>USBDevice.claimInterface()</code>.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web USB','#usbinterface','USBInterface')}}</td>
   <td>{{Spec2('Web USB')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.USBInterface")}}</p>
